/*
 * Copyright 2012-2013 eBay Software Foundation and ios-driver committers
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package org.libimobiledevice.ios.driver.binding.raw;
import com.sun.jna.Callback;
import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.NativeLibrary;
import com.sun.jna.Pointer;
import com.sun.jna.PointerType;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.PointerByReference;
import java.nio.IntBuffer;

import org.libimobiledevice.ios.driver.binding.raw.ImobiledeviceLibrary.lockdownd_service_descriptor;
/**
 * JNA Wrapper for library <b>imobiledevice-instruments</b><br>
 * This file was autogenerated by <a href="http://jnaerator.googlecode.com/">JNAerator</a>,<br>
 * a tool written by <a href="http://ochafik.com/">Olivier Chafik</a> that <a href="http://code.google.com/p/jnaerator/wiki/CreditsAndLicense">uses a few opensource projects.</a>.<br>
 * For help, please visit <a href="http://nativelibs4java.googlecode.com/">NativeLibs4Java</a> , <a href="http://rococoa.dev.java.net/">Rococoa</a>, or <a href="http://jna.dev.java.net/">JNA</a>.
 */
public class ImobiledeviceInstrumentsLibrary implements Library {
	public static final String JNA_LIBRARY_NAME = "imobiledevice-instruments";
	public static final NativeLibrary JNA_NATIVE_LIB = NativeLibrary.getInstance(ImobiledeviceInstrumentsLibrary.JNA_LIBRARY_NAME);
	static {
		Native.register(ImobiledeviceInstrumentsLibrary.class, ImobiledeviceInstrumentsLibrary.JNA_NATIVE_LIB);
	}
	public static final int INSTRUMENTS_E_TIMEOUT = (int)-7;
	public static final int INSTRUMENTS_PROTOCOL_VERSION_5 = (int)5;
	public static final int INSTRUMENTS_PROTOCOL_VERSION_6 = (int)6;
	public static final int INSTRUMENTS_E_MUX_ERROR = (int)-3;
	public static final int INSTRUMENTS_E_BAD_VERSION = (int)-5;
	public static final int INSTRUMENTS_E_UNKNOWN_ERROR = (int)-256;
	public static final int INSTRUMENTS_E_PLIST_ERROR = (int)-2;
	public static final String PROCESSCONTROL_SERVICE_NAME = (String)"com.apple.instruments.server.services.processcontrol";
	public static final int INSTRUMENTS_E_SSL_ERROR = (int)-4;
	public static final int INSTRUMENTS_E_START_SERVICE_ERROR = (int)-8;
	public static final int INSTRUMENTS_E_SUCCESS = (int)0;
	public static final int INSTRUMENTS_E_NO_MEM = (int)-6;
	public static final int INSTRUMENTS_E_INVALID_ARG = (int)-1;
	public static final String UIAUTOMATION_SERVICE_NAME = (String)"com.apple.instruments.UIAutomation";
	public interface uiautomation_message_handler_t extends Callback {
		int apply(Pointer client, Pointer message);
	};
	public interface uiautomation_exception_handler_t extends Callback {
		int apply(Pointer client, Pointer message, int line, Pointer source);
	};
	@Deprecated 
	public static native short instruments_client_new(Pointer device, lockdownd_service_descriptor service, Pointer client);
	public static native short instruments_client_new(ImobiledeviceInstrumentsLibrary.idevice_t device, lockdownd_service_descriptor service, PointerByReference client);
	public static native short instruments_client_new(Pointer device, lockdownd_service_descriptor service, PointerByReference client);
	@Deprecated 
	public static native short instruments_client_start_service(Pointer device, Pointer client, Pointer label);
	public static native short instruments_client_start_service(ImobiledeviceInstrumentsLibrary.idevice_t device, PointerByReference client, String label);
	public static native short instruments_client_start_service(Pointer device, PointerByReference client, Pointer label);
	@Deprecated 
	public static native short instruments_client_free(Pointer client);
	public static native short instruments_client_free(ImobiledeviceInstrumentsLibrary.instruments_client_t client);
	@Deprecated 
	public static native short instruments_client_get_protocol_version(Pointer client, IntByReference protocol_version);
	public static native short instruments_client_get_protocol_version(ImobiledeviceInstrumentsLibrary.instruments_client_t client, IntBuffer protocol_version);
	@Deprecated 
	public static native short instruments_client_set_protocol_version(Pointer client, int protocol_version);
	public static native short instruments_client_set_protocol_version(ImobiledeviceInstrumentsLibrary.instruments_client_t client, int protocol_version);
	@Deprecated 
	public static native short instruments_client_set_processing_interval(Pointer client, double interval);
	public static native short instruments_client_set_processing_interval(ImobiledeviceInstrumentsLibrary.instruments_client_t client, double interval);
	@Deprecated 
	public static native short instruments_client_set_throttle_constraints(Pointer client, int min, int average, int max);
	public static native short instruments_client_set_throttle_constraints(ImobiledeviceInstrumentsLibrary.instruments_client_t client, int min, int average, int max);
	@Deprecated 
	public static native short instruments_client_current_time(Pointer client, ImobiledeviceInstrumentsLibrary.timeval device_time);
	public static native short instruments_client_current_time(ImobiledeviceInstrumentsLibrary.instruments_client_t client, ImobiledeviceInstrumentsLibrary.timeval device_time);
	@Deprecated 
	public static native short instruments_client_service_requested_for_identifier(Pointer client, Pointer service_id, PointerByReference service_code);
	public static native short instruments_client_service_requested_for_identifier(ImobiledeviceInstrumentsLibrary.instruments_client_t client, String service_id, PointerByReference service_code);
	@Deprecated 
	public static native short instruments_client_request_channel_with_code(Pointer client, Pointer code, PointerByReference channel_id);
	public static native short instruments_client_request_channel_with_code(ImobiledeviceInstrumentsLibrary.instruments_client_t client, String code, PointerByReference channel_id);
	@Deprecated 
	public static native short instruments_client_set_max_connection_enqueue(Pointer client, long value);
	public static native short instruments_client_set_max_connection_enqueue(ImobiledeviceInstrumentsLibrary.instruments_client_t client, long value);
	@Deprecated 
	public static native short processcontrol_client_new(Pointer instr_client, Pointer client);
	public static native short processcontrol_client_new(ImobiledeviceInstrumentsLibrary.instruments_client_t instr_client, PointerByReference client);
	public static native short processcontrol_client_new(Pointer instr_client, PointerByReference client);
	@Deprecated 
	public static native short processcontrol_client_free(Pointer client);
	public static native short processcontrol_client_free(ImobiledeviceInstrumentsLibrary.processcontrol_client_t client);
	@Deprecated 
	public static native short processcontrol_client_process_identifier_for_bundle_identifier(Pointer client, Pointer bundle_identifier, IntByReference pid);
	public static native short processcontrol_client_process_identifier_for_bundle_identifier(ImobiledeviceInstrumentsLibrary.processcontrol_client_t client, String bundle_identifier, IntBuffer pid);
	@Deprecated 
	public static native short processcontrol_client_launch_suspended_process_with_device_path(Pointer client, Pointer device_path, Pointer target_bundle_id, PointerByReference environment, PointerByReference arguments, IntByReference pid);
	public static native short processcontrol_client_launch_suspended_process_with_device_path(ImobiledeviceInstrumentsLibrary.processcontrol_client_t client, String device_path, String target_bundle_id, PointerByReference environment, PointerByReference arguments, IntBuffer pid);
	@Deprecated 
	public static native short processcontrol_client_resume_pid(Pointer client, int pid);
	public static native short processcontrol_client_resume_pid(ImobiledeviceInstrumentsLibrary.processcontrol_client_t client, int pid);
	@Deprecated 
	public static native short processcontrol_client_kill_pid(Pointer client, int pid);
	public static native short processcontrol_client_kill_pid(ImobiledeviceInstrumentsLibrary.processcontrol_client_t client, int pid);
	@Deprecated 
	public static native short processcontrol_client_cleanup_pid(Pointer client, int pid);
	public static native short processcontrol_client_cleanup_pid(ImobiledeviceInstrumentsLibrary.processcontrol_client_t client, int pid);
	@Deprecated 
	public static native short processcontrol_client_start_observing_pid(Pointer client, int pid);
	public static native short processcontrol_client_start_observing_pid(ImobiledeviceInstrumentsLibrary.processcontrol_client_t client, int pid);
	@Deprecated 
	public static native short processcontrol_client_stop_observing_pid(Pointer client, int pid);
	public static native short processcontrol_client_stop_observing_pid(ImobiledeviceInstrumentsLibrary.processcontrol_client_t client, int pid);
	@Deprecated 
	public static native short processcontrol_client_launch_suspended_process_with_bundle_identifier(Pointer client, Pointer bundle_identifier, PointerByReference environment, PointerByReference arguments, IntByReference pid);
	public static native short processcontrol_client_launch_suspended_process_with_bundle_identifier(ImobiledeviceInstrumentsLibrary.processcontrol_client_t client, String bundle_identifier, PointerByReference environment, PointerByReference arguments, IntBuffer pid);
	@Deprecated 
	public static native short uiautomation_client_new(Pointer instr_client, Pointer client);
	public static native short uiautomation_client_new(ImobiledeviceInstrumentsLibrary.instruments_client_t instr_client, PointerByReference client);
	public static native short uiautomation_client_new(Pointer instr_client, PointerByReference client);
	@Deprecated 
	public static native short uiautomation_client_free(Pointer client);
	public static native short uiautomation_client_free(ImobiledeviceInstrumentsLibrary.uiautomation_client_t client);
	@Deprecated 
	public static native short uiautomation_client_set_message_handler(Pointer client, ImobiledeviceInstrumentsLibrary.uiautomation_message_handler_t handler);
	public static native short uiautomation_client_set_message_handler(ImobiledeviceInstrumentsLibrary.uiautomation_client_t client, ImobiledeviceInstrumentsLibrary.uiautomation_message_handler_t handler);
	@Deprecated 
	public static native short uiautomation_client_set_exception_handler(Pointer client, ImobiledeviceInstrumentsLibrary.uiautomation_exception_handler_t handler);
	public static native short uiautomation_client_set_exception_handler(ImobiledeviceInstrumentsLibrary.uiautomation_client_t client, ImobiledeviceInstrumentsLibrary.uiautomation_exception_handler_t handler);
	@Deprecated 
	public static native int uiautomation_client_get_script_status(Pointer client);
	public static native int uiautomation_client_get_script_status(ImobiledeviceInstrumentsLibrary.uiautomation_client_t client);
	@Deprecated 
	public static native int uiautomation_client_get_agent_ready(Pointer client);
	public static native int uiautomation_client_get_agent_ready(ImobiledeviceInstrumentsLibrary.uiautomation_client_t client);
	@Deprecated 
	public static native int uiautomation_client_get_exception_status(Pointer client);
	public static native int uiautomation_client_get_exception_status(ImobiledeviceInstrumentsLibrary.uiautomation_client_t client);
	@Deprecated 
	public static native short uiautomation_client_configure_launch_environment(Pointer client, PointerByReference environment);
	public static native short uiautomation_client_configure_launch_environment(ImobiledeviceInstrumentsLibrary.uiautomation_client_t client, PointerByReference environment);
	@Deprecated 
	public static native short uiautomation_client_start_agent_for_app_with_pid(Pointer client, Pointer target_bundle_id, int pid);
	public static native short uiautomation_client_start_agent_for_app_with_pid(ImobiledeviceInstrumentsLibrary.uiautomation_client_t client, String target_bundle_id, int pid);
	@Deprecated 
	public static native short uiautomation_client_start_script(Pointer client, Pointer script_body);
	public static native short uiautomation_client_start_script(ImobiledeviceInstrumentsLibrary.uiautomation_client_t client, String script_body);
	@Deprecated 
	public static native short uiautomation_client_start_script_with_info(Pointer client, Pointer target_bundle_id, Pointer script_body, Pointer script_url);
	public static native short uiautomation_client_start_script_with_info(ImobiledeviceInstrumentsLibrary.uiautomation_client_t client, String target_bundle_id, String script_body, String script_url);
	@Deprecated 
	public static native short uiautomation_client_pause_script(Pointer client);
	public static native short uiautomation_client_pause_script(ImobiledeviceInstrumentsLibrary.uiautomation_client_t client);
	@Deprecated 
	public static native short uiautomation_client_resume_script(Pointer client);
	public static native short uiautomation_client_resume_script(ImobiledeviceInstrumentsLibrary.uiautomation_client_t client);
	@Deprecated 
	public static native short uiautomation_client_stop_script(Pointer client);
	public static native short uiautomation_client_stop_script(ImobiledeviceInstrumentsLibrary.uiautomation_client_t client);
	@Deprecated 
	public static native short uiautomation_client_take_screenshot(Pointer client);
	public static native short uiautomation_client_take_screenshot(ImobiledeviceInstrumentsLibrary.uiautomation_client_t client);
	/** Pointer to unknown (opaque) type */
	public static class idevice_t extends PointerType {
		public idevice_t(Pointer address) {
			super(address);
		}
		public idevice_t() {
			super();
		}
	};
	/** Pointer to unknown (opaque) type */
	public static class processcontrol_client_t extends PointerType {
		public processcontrol_client_t(Pointer address) {
			super(address);
		}
		public processcontrol_client_t() {
			super();
		}
	};
	/** Pointer to unknown (opaque) type */
	public static class instruments_client_t extends PointerType {
		public instruments_client_t(Pointer address) {
			super(address);
		}
		public instruments_client_t() {
			super();
		}
	};
	/** Pointer to unknown (opaque) type */
	public static class timeval extends PointerType {
		public timeval(Pointer address) {
			super(address);
		}
		public timeval() {
			super();
		}
	};
	/** Pointer to unknown (opaque) type */
	public static class uiautomation_client_t extends PointerType {
		public uiautomation_client_t(Pointer address) {
			super(address);
		}
		public uiautomation_client_t() {
			super();
		}
	};
}
